package de.uni_marburg.powersort.benchmark;

import de.uni_marburg.powersort.sort.DummySort;
import de.uni_marburg.powersort.sort.MergeSort;
import de.uni_marburg.powersort.sort.TimSort;
import de.uni_marburg.powersort.data.RandomIntegers;
import org.openjdk.jmh.annotations.*;

import java.util.concurrent.TimeUnit;

// TODO: The parameters are way too low. Use for debugging only!
/*
 * Benchmark parameters
 */
@Fork(0)
@Warmup(iterations = 0)
@Measurement(iterations = 1)
@BenchmarkMode(Mode.AverageTime)
@OutputTimeUnit(TimeUnit.MILLISECONDS)
/*
 * Benchmark state parameters
 *
 * Quote from JMH:
 * State objects naturally encapsulate the state on which benchmark is working on.
 */
@State(Scope.Benchmark)
public class BenchmarkJmh {
    private final RandomIntegers readonly = new RandomIntegers();
    /* package-protected */ Integer[] array;

    // TODO: This is inaccurate. How to create and use separate arrays for each warmup x iteration x sortAlgorithm ?
    @Setup(Level.Invocation)
    public void setup() {
        array = readonly.getCopy();
    }

    @Benchmark
    public void rand1DummySort() {
        DummySort.sort(array, 0, array.length, NaturalOrder.INSTANCE, null, 0, 0);
    }

    @Benchmark
    public void rand1TimSort() {
        TimSort.sort(array, 0, array.length, NaturalOrder.INSTANCE, null, 0, 0);
    }

    @Benchmark
    public void rand1MergeSort() {
        MergeSort.legacyMergeSort(array, NaturalOrder.INSTANCE);
    }
}
