package de.uni_marburg.powersort.benchmark;

public class IntegerArray {
    private IntegerArray() {
    }

    public static Integer[] random(final int length) {
        return random(length, Integer.MIN_VALUE, Integer.MAX_VALUE);
    }

    public static Integer[] random(final int length, final int minInt, final int maxInt) {
        final Integer[] list = new Integer[length];
        for (int i = 0; i < length; i++) {
            list[i] = RandomInt.integer(minInt, maxInt);
        }
        return list;
    }

    /**
     * @return [start, start-1, ..., end+1, end]
     */
    public static Integer[] descending(final int start, final int end) {
        assert start > end;

        Integer[] list = new Integer[start - end + 1];
        for (int i = 0; i < list.length; i++) {
            int value = start - i;
            list[i] = value;
        }

        assert list[0] == start;
        assert list[list.length - 1] == end;
        return list;
    }
}
